Subject: Re: [PATCH] refs: support migration with worktrees

From: Patrick Steinhardt <[email-masked]>
Date: Thu, 30 Oct 2025 07:37:25 +0100

On Wed, Oct 29, 2025 at 12:33:15PM +0100, Kristoffer Haugsbakk wrote:
> On Wed, Oct 29, 2025, at 11:10, Patrick Steinhardt wrote:
> > On Tue, Oct 28, 2025 at 09:00:43AM -0700, Junio C Hamano wrote:
> >> Patrick Steinhardt <[email-masked]> writes:
> >>
> >> >>  `migrate`::
> >> >> -	Migrate ref store between different formats.
> >> >> +	Migrate ref store between different formats. Supports repositories
> >> >> +	with worktrees; migration must be run from the main worktree.
> >> >
> >> > It feels a bit weird to single our worktrees specifically. We don't say
> >> > that the tool supports bare and non-bare repositories, either, so the
> >> > only reason why we'd have the note about worktrees is historic legacy.
> >> > How about this instead:
> >> >
> >> >     Migrate ref storage between different formats. Must be run from the
> >> >     main worktree in case the repository uses worktrees.
> >>
> >> Two thoughts.
> >>
> >>  * Would it be unacceptable if the primary repository and refstore
> >>    uses reftable backend, and a newly attached worktree to the
> >>    repository uses ref-files only for its per-worktree refs?  If we
> >>    should allow it, then "if the ref store you are migrating is in a
> >>    repository with multiple worktrees, you must migrate from the
> >>    primary and migrate _all_ ref store for all worktrees at once,
> >>    into the same backend", which the design of this patch seems to
> >>    aim at, would contradict with it, no?
> >
> > The problem we have here is backwards compatibility. Right now we assume
> > that `extensions.refStorage` applies to all worktrees, so if we wanted
> > to change it like you propose then we'd have to introduce a backwards
> > incompatible change.
> 
> I don’t understand the motivation or use case for supporting different
> backends for different worktrees. But Junio would have to explain that.
> 
> Maybe the motivation is this weird (from a user’s perspective) limi-
> tation that you have to run a command from the main worktree?  Okay,
> that’s strange but you get the error and switch to wherever the main
> worktree is (that the error message hopefully helpfully provides you
> with) and run the command there.  Then you forget that weird thing five
> minutes later since this was a one-off command.
> 
> >
> > I agree though that it would've been great if we would have said from
> > the beginning that the worktree-specific configuration is allowed to
> > override the ref storage format for a worktree. If so, we could easily
> > convert any of the worktrees (including the main one) by without having
> > any impact on all the other worktrees.
> 
> As a user I don’t understand why that is a great thing to have.

I am commenting more from the developer side here. In the best case the
user wouldn't ever care what ref storage format they use. We simply pick
the best format available and the user lives happily ever after.

But from a developer standpoint it matters. If we had per-worktree ref
formats we would for example be able to make the ref migration code a
lot more robust, as we could now migrate worktrees one by one. In the
current situation we basically have to migrate all worktrees at once,
and that significantly increases the risk of the migration going wrong
at any point in time.

> >
> > But we do not live in such a world right now, and getting there would
> > require some significant reworking of how we handle per-worktree
> > references. Unfortunate, but I also don't think there's a strong enough
> > reason to change this.
> >
> >>  * If "you must do so from the primary worktree and we convert all
> >>    the worktrees attached to the same repository" is the only mode
> >>    of operation we support (which by the way I have no problem
> >>    with---the first bullet point above was asking question, not
> >>    suggesting change of design), then would it be easier for the
> >>    user to use if the command noticed that it is not in the primary
> >>    worktree and switched to it for the user, instead of complaining
> >>    and failing?
> >
> > I'm not sure. The question is whether the user recognizes that migrating
> > references in the worktree would also migrate references in the main
> > repository. It might be surprising behaviour if we did that without
> > asking.
> 
> On the contrary, as a user I think it mattering what worktree I run this
> command from sounds very weird.  (But again I can tolerate it requiring
> me to run it from the main worktree if there are technical difficulties/
> limitations.  But using different backends for different
> worktrees is very weird, again.)
> 
> If I run `git gc` I don’t want it to do different things based on what
> worktree I am. I want to operate on the repository, and the repository
> is the same no matter what worktree I am in.  The same principle applies
> to this command in my mind.

It does though :) Only very slightly so, but for example maintenance of
references is dependent on the worktree you are in. We don't maintain
references from other worktrees. So it's not really a new thing that I'm
proposing here.

In any case, I'm happy to change my stance if the majority of folks
thinks that migrating the whole repository from secondary worktrees is
fine. I mostly wanted to avoid that operations that the user perform
have a wider blast radius than they understood, but if everyone agrees
that this is a non-issue then I don't mind much. It's only going to make
the implementation simpler.

Patrick